set more off

cap program drop hprob7
program define hprob7
	args lnf xb1 xb2 xb3
	tempvar pref_rep pref_pres rho23
	gen `rho23' = (exp(2*`xb3')-1)/(exp(2*`xb3')+1)
	qui gen `pref_rep' = `xb1'
	qui gen `pref_pres' = `xb2'
	quietly replace `lnf'=ln(binormal(`pref_rep',`pref_pres',`rho23')) if presidential==1&voted_house_rep==1&voted_pres_rep==1
	quietly replace `lnf'=ln(binormal(-`pref_rep',`pref_pres',-`rho23')) if presidential==1&voted_house_rep==0&voted_pres_rep==1
	quietly replace `lnf'=ln(binormal(`pref_rep',-`pref_pres',-`rho23')) if presidential==1&voted_house_rep==1&voted_pres_rep==0
	quietly replace `lnf'=ln(binormal(-`pref_rep',-`pref_pres',`rho23')) if presidential==1&voted_house_rep==0&voted_pres_rep==0
	quietly replace `lnf'=ln(normal(`pref_rep')) if presidential==0&voted_house_rep==1
	quietly replace `lnf'=ln(normal(-`pref_rep')) if presidential==0&voted_house_rep==0
	end
	
ml model lf hprob7 (house: voted_house_rep = party_centered pres_rep2) ///
(pres: voted_pres_rep = party_centered year52 year56 year60 year64 year68 year72 year76 year80 year84 year88 year92 year96 year00 year04 year08, nocons) ///
(rho23: voted = one, nocons) [pweight = VCF0009a] if voted==1, ///
maximize missing trace difficult iterate(200)

cap drop house_pref pres_pref abs_house_pref abs_pres_pref sq_house_pref sq_pres_pref b_*

matrix b_first=e(b)

predict house_pref, index equation(house)
predict pres_pref, index equation(pres)

gen abs_house_pref=abs(house_pref)
gen abs_pres_pref=abs(pres_pref)
replace abs_pres_pref=0 if presidential==0

gen sq_house_pref=(house_pref)^2
gen sq_pres_pref=(pres_pref)^2
replace sq_pres_pref=0 if presidential==0

probit voted abs_house_pref abs_pres_pref [pweight = VCF0009a]
matrix b_abs1=e(b)
probit voted abs_house_pref abs_pres_pref presidential [pweight = VCF0009a]
matrix b_abs2=e(b)

probit voted sq_house_pref sq_pres_pref [pweight = VCF0009a]
matrix b_sq1=e(b)
probit voted sq_house_pref sq_pres_pref presidential [pweight = VCF0009a]
matrix b_sq2=e(b)

probit voted abs_house_pref abs_pres_pref senate_election_year governor_election_year [pweight = VCF0009a]
matrix b_other1=e(b)
probit voted abs_house_pref abs_pres_pref senate_election_year governor_election_year  presidential [pweight = VCF0009a]
matrix b_other2=e(b)

svmat b_first 
svmat b_abs1 
svmat b_abs2 
svmat b_sq1 
svmat b_sq2 
svmat b_other1 
svmat b_other2

keep b_*

drop if _n>1
